#!/bin/bash
# Copyright 2017 Michal Žejdl
# a wrapper for fdb2graph binary
# - launches it, sends part of its output to $mysqlwpipe
# - kills it when stop.sh is calling

confdir=$(dirname $0)
config=$confdir/defaults.sh
test -f $config || exit
. $config

# take the binary from src until there will be make install
fdb2graph=$confdir/../src/fdb2graph/fdb2graph
#pidfile=$rundir/fdb2graph.pid

# exit if the binary doesn't exist
test -x $fdb2graph || exit

# a new file descriptor to prevent pipe from closing
exec 3> $mysqlwpipe

# start from scratch
echo "delete from fdb2graph_neighbour;" >&3

# launch the binary; filter output and pass only SQL statements to named pipe
nice -19 $fdb2graph $dbhost $dbruser $dbrpass $dbname \
		| grep --line-buffered fdb2graph_ >&3 &

# pid of $fdb2graph (jobspec points to the first job in chain)
# but %1 is unusable - points to earlier jobs
#jobs -x echo %1 >$pidfile

# wait for stop.sh here
while true; do
	# stop this golem if "šém" is removed
	test -e $rundir/$(basename $0 .sh).sem || break
	sleep 1
done

# stop the binary
#kill $(cat $pidfile)
killall $fdb2graph

# cleanup
#rm $pidfile
