#!/bin/bash
# Copyright 2009 - 2019 Michal Žejdl
# init script for user root; symlink this somewhere to $PATH

confdir=$(dirname $(readlink -f $0))
config=$confdir/defaults.sh
test -f "$config" || exit
source "$config"

function usage_and_exit
{
	echo "Usage: $(basename $0) <start|stop|restart|status>"
	exit
}

function init_dir
{
	local dir
	for dir in $@
	do
		if test ! -d "$dir"
		then
			mkdir -p "$dir" || exit
			chown "$user:" "$dir" || exit
		fi
	done
}

test $# -eq 1 || usage_and_exit

action=$1

case "$action" in
#"start" | "stop")
	# login shell is for netldb/snmp/dispatcher.sh - rewrite needed
	# find: cannot get current directory
#	su -c $coredir/$action.sh - $user
"start")
	init_dir "$rundir" "$rundir/snmp" "$logdir" "$logdir/snmp"
	init_dir "$rrddir" "$rrddir/snmpagent" "$rrdstatsdir"

	su -c $coredir/start.sh - $user
	;;
"stop")
	su -c $coredir/stop.sh $user
	;;
"restart")
	su -c $coredir/stop.sh $user
	su -c $coredir/start.sh - $user
	;;
"status")
	tail -n3 $logdir/*.out $logdir/*.err
	;;
*)
	usage_and_exit
esac
