#!/bin/bash
# Copyright 2010, 2014, 2015 Michal Žejdl
# přečte SNMP prvku zadaného DNS jménem; volající skript je dispatcher.sh

confdir=$(dirname $0)/../../core
config=$confdir/defaults.sh
test -f $config || exit
. $config

prvek=$1

snmpdir=$coredir/snmp
snmp=$netldbdir/snmp

exec 3> $mysqlwpipe

# rychlá (-m '') kontrola sysObjectID,
# jestli už to není jinak, než zjistil checker.sh
if ! snmpget -v 1 -c public -m '' $prvek .1.3.6.1.2.1.1.2.0 &> /dev/null; then
  # je problém s SNMP - řekneme, že není prvek živý a zbytek zařídí checker.sh
  echo "update checked \
set live = 'n', collecting = 'n' where dns = '$prvek';" >&3
  echo $prvek má problém, končím
  exit
fi

$snmp/sys.sh $prvek
#$snmp/fdb.sh $prvek
$snmpdir/fdb.sh $prvek

# máme hotovo
# nastavením lastsnmpread na teď posouváme další spuštění o dobu čtení SNMP,
# což rozloží čtení všech SNMP rovnoměrně přes celý interval
echo "update checked set collecting = 'n', lastsnmpread = unix_timestamp() where dns = '$prvek';" >&3
