#!/bin/bash
# Copyright 2016 - 2018 Michal Žejdl
# MikroTik mtxrWlAp - ClientCount

# at least five args are required
test $# -lt 5 && exit

rrdbasedir=$1
rrdfile=$2
outputdir=$3
starttime=$4
endtime=$5

# make the remote flush possible
cd $rrdbasedir || exit

test -d "$outputdir" || mkdir -p "$outputdir" || exit

# lazy (-z) is handy
options="-s $starttime -e $endtime -z"

# append rrdcached
test $# -gt 5 && options="$options --daemon $6"

filename=$(basename $rrdfile .rrd)

rrdtool graph \
$outputdir/mikrotik-$filename-ClientCount-$starttime-$endtime.png \
$options -t "ClientCount" -v "count" \
DEF:ca=$rrdfile:ClientCount:AVERAGE \
DEF:cn=$rrdfile:ClientCount:MIN \
DEF:cm=$rrdfile:ClientCount:MAX \
DEF:cl=$rrdfile:ClientCount:LAST \
VDEF:caa=ca,AVERAGE \
VDEF:cnn=cn,MINIMUM \
VDEF:cmm=cm,MAXIMUM \
VDEF:cll=cl,LAST \
TEXTALIGN:left \
LINE2:ca#0000cc:"  " \
GPRINT:caa:"avg\: %6.2lf %s" \
GPRINT:cnn:"min\: %6.2lf %s" \
GPRINT:cmm:"max\: %6.2lf %s" \
GPRINT:cll:"lst\: %6.2lf %s\l"
