<?php

/*
 * Copyright 2016 - 2018 Michal Žejdl
 */

$document_root = "../..";

require "$document_root/init.php";

$title = "Telindus lineParameters and performance";

page_open($document_root, $title);


// enable debug_print()
//$debug = true;

// init db
$connection = mysql_connect($dbhost, $dbuser, $dbpass);
if (!$connection) exit;
mysql_select_db($dbname);

if (isset($_GET["agent"])) {
	$snmpagentid = $_GET["agent"];
	// validity check
	if (!preg_match("/^[[:digit:]]+$/", $snmpagentid)) exit;

	/*
	// start is not required
	if (isset($_GET["start"]) 
			and preg_match("/^[[:alnum:]-]+$/", $_GET["start"]))
		$start = $_GET["start"];
	// PHP automagicaly initializes variables from URL
	else unset($start);
	
	// end is not required
	if (isset($_GET["end"])
			and preg_match('/^[[:alnum:]-]+$/', $_GET["end"]))
		$end = $_GET["end"];
	else unset($end);
	*/

	print_snmp_header($document_root, $snmpagentid);

	echo "<h2>$title</h2>\n";

	/*
	// the form above tests $end presence; now we can initialize it
	if (!isset($end)) $end = "now";
	*/

	// common variables for RRD graphs
	$thisdir = dirname(__FILE__);
	$bindir = $thisdir . "/../../bin";
	$outputdir = "imgcache/" . $snmpagentid;
	if (!is_dir($outputdir))
		if (!mkdir($outputdir, 0777, true))
			exit("<p>mkdir($outputdir) failed");

	/*
	if (isset($start)) $starts = array($start);
	else $starts = array("now-1d", "now-1w", "now-1m", "now-1y");
	*/

	// a new approach
	$end = get_end();
	$start = get_start($end);
	print_start_end_selector($start, $end);

	for ($linePair = 1; $linePair <= 2; $linePair++) {

		$rrdfile = "snmpagent/" . $snmpagentid .
			"/Telindus/linePair" . $linePair . ".rrd";

		if (!file_exists($rrdbasedir . "/" . $rrdfile)) continue;

		if (is_rrd_obsolete($rrdbasedir . "/" . $rrdfile, $start))
			continue;

		echo "<h3>linePair[$linePair]</h3>\n";

		echo "<p class=\"center\">\n";

		//foreach ($starts as $start) {
		$command = "$bindir/graph-telindus.sh"
			. " $rrdbasedir $rrdfile"
			. " $thisdir/$outputdir $start $end";
		if (! empty($rrdcached))
			$command .= " $rrdcached";
		debug_print($command);
		exec($command);
		echo "<img alt=\"lineParameters\"",
		     " src=\"$outputdir/telindus-linePair$linePair",
		     "-lineParameters",
		     "-$start-$end.png\">";
		echo "<img alt=\"performance\"",
		     " src=\"$outputdir/telindus-linePair$linePair",
		     "-performance",
		     "-$start-$end.png\">";
		echo "<br>\n";
		//}
	}
}



page_close($document_root);

?>
