<?php

/*
 * Copyright 2017 - 2018 Michal Žejdl
 */

$document_root = "../..";

require "$document_root/init.php";

$title = gettext("dot1dBridge FdbTable");

page_open($document_root, $title);



if (!isset($_GET["agent"])) exit;

$snmpagentid = $_GET["agent"];
  
// validity check
if (!preg_match("/^[[:digit:]]+$/", $snmpagentid)) exit;


if (isset($_GET["order"]))

	switch ($_GET["order"]) {
		case "time":
			$order = "time desc, port";
			break;
		case "port":
			$order = "port, time desc";
			break;
		case "ifdescr":
			$order = "ifDescr, time desc";
			break;
		case "ifspeed":
			$order = "ifSpeed desc, port, time desc";
			break;
		case "mac":
			$order = "mac";
			break;
		case "vlan":
			$order = "vlan, port, time desc";
			break;
		case "ipv4":
			$order = "inet_aton(arp1.ip)";
			break;
		case "ipv6":
			$order = "ip6";
			break;
		default:
			$order = "time desc, port";
	}

else $order = "time desc, port";



$connection = mysql_connect($dbhost, $dbuser, $dbpass);

if (!$connection)
	exit(gettext("database connection error"));

mysql_select_db($dbname);


print_snmp_header($document_root, $snmpagentid);

echo "<h2>$title</h2>\n";


$result = mysql_query("select sysObjectID
		from snmpagent where id = $snmpagentid");

if (! ($row = mysql_fetch_assoc($result)))
	exit;

$organization = sysObjectID2organization($row["sysObjectID"]);

switch ($organization) {
	case "MikroTik":
		# MikroTik doesn't fill the portIfIndex table
		# but uses fdb port as ifIndex
		$bit_of_join = "left join mibifentry as mibifentry_a
			on agent_a = mibifentry_a.agent
			and port_a = mibifentry_a.ifIndex";
		break;
	default:
		$bit_of_join = "left join mibportifindex as mibportifindex_a
			on agent_a = mibportifindex_a.agent
			and port_a = mibportifindex_a.port
			left join mibifentry as mibifentry_a
			on mibportifindex_a.agent = mibifentry_a.agent
			and mibportifindex_a.ifIndex = mibifentry_a.ifIndex";
}

$result = mysql_query("select
		port_a, mibifentry_a.ifIndex ifIndex_a,
		mibifentry_a.ifDescr ifDescr_a,
		port_b, mibifentry_b.ifIndex ifIndex_b,
		mibifentry_b.ifDescr ifDescr_b,
		agent_b, sysName
		from fdb2graph_neighbour
		$bit_of_join
		left join mibportifindex as mibportifindex_b
		on agent_b = mibportifindex_b.agent
		and port_b = mibportifindex_b.port
		left join mibifentry as mibifentry_b
		on mibportifindex_b.agent = mibifentry_b.agent
		and mibportifindex_b.ifIndex = mibifentry_b.ifIndex
		join snmpagent on agent_b = id
		where agent_a = $snmpagentid order by port_a");

$num_rows = mysql_num_rows($result);

if ($num_rows > 0) {

	echo "<h3>", gettext("neighbouring switches (bridges)"), "</h3>\n";
	echo "<p>\n";
	echo "<table summary=\"fdb2graph_neighbour\">\n";
	echo "<tr>",
	     "<th>port",
	     "<th>ifDescr (", gettext("graphs"), ")",
	     "<th>remote port",
	     "<th>ifDescr (", gettext("graphs"), ")",
	     "<th>remote bridge",
	     "\n";

	echo "<tbody>\n";
	while ($row = mysql_fetch_array($result)) {

		echo "<tr class=\"monospace zebra\">";

		echo "<td>",
		     "<a href=\"fdbport.php?agent=", $snmpagentid,
		     "&amp;port=", $row["port_a"], "\">", $row["port_a"],
		     "</a>";

		echo "<td>";
		if (! is_null($row["ifDescr_a"]))
			echo "<a href=\"",
			     "ifgraph.php",
			     "?agent=", $snmpagentid,
			     "&amp;index=", $row["ifIndex_a"],
			     "\">",
			     $row["ifDescr_a"],
			     "</a>";

		echo "<td class=\"right\">",
		     "<a href=\"fdbport.php?agent=", $row["agent_b"],
		     "&amp;port=", $row["port_b"], "\">", $row["port_b"],
		     "</a>";

		echo "<td>";
		if (! is_null($row["ifDescr_b"]))
			echo "<a href=\"",
			     "ifgraph.php",
			     "?agent=", $row["agent_b"],
			     "&amp;index=", $row["ifIndex_b"],
			     "\">",
			     $row["ifDescr_b"],
			     "</a>";

		echo "<td>";
		print_link_to_agent("fdb.php?agent=", $row["agent_b"],
				$row["sysName"]);
		echo "\n";
	}
	echo "</tbody>\n";
	echo "</table>\n";
}

/*

see fdbport.php

$result = mysql_query("select
		mibfdbport.time time,
		port, ifIndex, ifDescr,
		replace(format(ifSpeed, 0), ',', '&nbsp;') ifSpeed,
		mac, ip, ip6
		from mibfdbport
		left join mibportifindex using(agent, port)
		left join mibifentry using (agent, ifIndex)
		left join arp using(mac)
		left join nd using(mac)
		where agent = $snmpagentid
		and port not in
		(select port_a from fdb2graph_neighbour
		 where agent_a = $snmpagentid)
		and (arp.time =
		(select max(time) from arp sub_arp where sub_arp.mac = arp.mac)
		or arp.time is null)
		and (nd.time =
		(select max(time) from nd sub_nd where sub_nd.mac = nd.mac)
		or nd.time is null)
		order by time desc, port");
*/



// check if there is any VLAN number

$result = mysql_query("select count(vlan) from mibfdbport
		where agent = $snmpagentid and vlan is not null");

$row = mysql_fetch_array($result);

$vlan_count = $row["count(vlan)"];


switch ($organization) {
	case "MikroTik":
		# MikroTik doesn't fill the portIfIndex table
		# but uses fdb port as ifIndex
		$bit_of_join = "left join mibifentry
			on mibfdbport.agent = mibifentry.agent
			and mibfdbport.port = mibifentry.ifIndex";
		break;
	default:
		$bit_of_join = "left join mibportifindex using(agent, port)
			left join mibifentry using (agent, ifIndex)";
}

$snmpdelay = 2 * $snmpinterval;

$result = mysql_query("select
		mibfdbport.time time,
		mibfdbport.vlan vlan,
		port, ifIndex, ifDescr,
		replace(format(ifSpeed, 0), ',', '&nbsp;') ifSpeed,
		mibfdbport.mac mac,
		arp1.ip, arp2.ip arp2ip, nd1.ip6, nd2.ip6 nd2ip6
		from mibfdbport
		$bit_of_join
		left join arp arp1
		on mibfdbport.mac = arp1.mac
		and mibfdbport.time + $snmpdelay > arp1.time
		left join arp arp2
		on mibfdbport.mac = arp2.mac
		and mibfdbport.time + $snmpdelay > arp2.time
		and arp1.time < arp2.time
		left join nd nd1
		on mibfdbport.mac = nd1.mac
		and mibfdbport.time + $snmpdelay > nd1.time
		left join nd nd2
		on mibfdbport.mac = nd2.mac
		and mibfdbport.time + $snmpdelay > nd2.time
		and nd1.time < nd2.time
		where mibfdbport.agent = $snmpagentid
		and port not in
		(select port_a from fdb2graph_neighbour
		 where agent_a = $snmpagentid)
		and arp2.time is null
		and nd2.time is null
		order by $order");

if (mysql_num_rows($result) > 0) {

	$anchor = $_SERVER["SCRIPT_NAME"] . "?agent=" . $snmpagentid
		. "&amp;order=";

	echo "<h3>", gettext("ports without neighbouring switches"), "</h3>\n";
	echo "<p>\n";
	echo "<table summary=\"FdbTable\">\n";

	echo "<tr>";
	echo "\n";

	echo "<th>";
	print_url($anchor . "time", "time");
	echo "\n";

	echo "<th>";
	print_url($anchor . "port", "port");
	echo "\n";

	echo "<th>";
	print_url($anchor . "ifdescr", "ifDescr");
	echo " (", gettext("graphs"), ")";
	echo "\n";

	echo "<th>";
	print_url($anchor . "ifspeed", "ifSpeed");
	echo "\n";

	echo "<th>";
	print_url($anchor . "mac", "MAC");
	echo "\n";

	if ($vlan_count) {
		echo "<th>";
		print_url($anchor . "vlan", "VLAN");
		echo "\n";
	}

	echo "<th>";
	print_url($anchor . "ipv4", "IPv4");
	echo "\n";

	echo "<th>PTR\n";

	echo "<th>";
	print_url($anchor . "ipv6", "IPv6");
	echo "\n";

	echo "<th>PTR\n";

	$row_number = 0;
	$timestamp = time();

	while ($row = mysql_fetch_array($result)) {

		echo "<tr class=\"monospace ",
		     tr_aging_class(++$row_number, $timestamp - $row["time"]),
		     "\">";

		echo "<td>", date_formated($row["time"]);

		echo "<td class=\"right\">",
		     "<a href=\"fdbport.php?agent=", $snmpagentid,
		     "&amp;port=", $row["port"], "\">", $row["port"],
		     "</a>";

		echo "<td>";

		if (! is_null($row["ifIndex"]))

			echo "<a href=\"ifgraph.php",
			     "?agent=$snmpagentid&amp;index=",
			     $row["ifIndex"], "\">",
			     $row["ifDescr"], "</a>";

		echo "<td class=\"right\">";

		if (! is_null($row["ifSpeed"]))

			echo $row["ifSpeed"];

		echo "<td>",
		     "<a href=\"../../mac.php",
		     "?id=", $row["mac"], "\">",
		     $row["mac"], "</a>";

		if ($vlan_count)
			echo "<td class=\"right\">", $row["vlan"];

		echo "<td>";

		if (! is_null($row["ip"]))

			echo "<a href=\"",
			     "../../ipv4.php",
			     "?id=", $row["ip"],
			     "\">",
			     $row["ip"],
			     "</a>";

		echo "<td>";

		if (! is_null($row["ip"])) {

			$name = address2name($row["ip"]);

			if (! empty($name))

				echo "<a href=\"",
				     "../../dns.php",
				     "?id=", $name,
				     "\">",
				     "$name",
				     "</a>";
		}

		echo "<td>";

		if (! is_null($row["ip6"]))

			echo "<a href=\"",
			     "../../ipv6.php",
			     "?id=", $row["ip6"],
			     "\">",
			     ipv6_compress($row["ip6"]),
			     "</a>";

		echo "<td>";

		if (! is_null($row["ip6"])) {

			$name = address2name($row["ip6"]);

			if (! empty($name))

				echo "<a href=\"",
				     "../../dns.php",
				     "?id=", $name,
				     "\">",
				     "$name",
				     "</a>";
		}

		echo "\n";
	}

	echo "</table>\n";
}



page_close($document_root);

?>
