<?php

/*
 * Copyright 2018 Michal Žejdl
 */

$document_root = "../..";

require "$document_root/init.php";

$title = "hostResources MIB";

page_open($document_root, $title);

// enable debug_print()
//$debug = true;

// init db
$connection = mysql_connect($dbhost, $dbuser, $dbpass);
if (!$connection) exit;
mysql_select_db($dbname);

if (isset($_GET["agent"])) {

	$snmpagentid = $_GET["agent"];
	// validity check
	if (!preg_match("/^[[:digit:]]+$/", $snmpagentid)) exit;

	print_snmp_header($document_root, $snmpagentid);

	echo "<h2>$title</h2>\n";

	// common variables for RRD graphs
	$thisdir = dirname(__FILE__);
	$bindir = $thisdir . "/../../bin";
	$outputdir = "imgcache/" . $snmpagentid;
	if (!is_dir($outputdir))
		if (!mkdir($outputdir, 0777, true))
			exit("<p>mkdir($outputdir) failed");

	$datasources = array("hrProcessorLoad");

	$end = get_end();
	$start = get_start($end);
	print_start_end_selector($start, $end);

	foreach ($datasources as $datasource) {

		$rrdfile = "snmpagent/" . $snmpagentid .
			"/hostResources/" . $datasource . ".rrd";

		$filename = $rrdbasedir . "/" . $rrdfile;

		if (!file_exists($filename))
			continue;

		if (is_rrd_obsolete($filename, $start))
			continue;

		switch ($datasource) {
			case "hrProcessorLoad":
				$title = "ProcessorLoad";
				$vlabel = "%";
				break;
		}

		$command = "$bindir/graph-blue-line.sh"
			. " $rrdbasedir $rrdfile"
			. " $thisdir/$outputdir $start $end"
			. " $title $vlabel";
		if (! empty($rrdcached))
			$command .= " $rrdcached";
		debug_print($command);
		exec($command);

		echo "<h3>$datasource</h3>\n";

		if ($datasource == "hrProcessorLoad" and $snmpinterval > 60) {

			echo "<p>";
			echo gettext("hrProcessorLoad is the last minute average, but the interval between two SNMP reads is larger. Due this the next graph is incomplete.");
		}

		echo "<p class=\"center\">\n";

		echo "<img alt=\"$datasource\"",
		     " src=\"$outputdir/",
		     "$datasource",
		     "-$start-$end.png\">";
		echo "<br>\n";
	}
}

page_close($document_root);

?>
